#include <iostream>
#include <vector>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    Input in;
    size_t numbers_count;
    cout << "Enter numbers count: ";
    cin >> numbers_count;
    in.numbers.resize(numbers_count);

    cout << "Enter numbers: ";
    for (size_t i = 0; i < numbers_count; i++) {
        cin >> in.numbers[i];
    }

    cout << "Enter bin count: ";
    cin >> in.bin_count;
    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    max = numbers[0];

    for (double x : numbers){
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
}

vector<size_t> make_histogram(const vector<double>& numbers, size_t bin_count){
    double min, max;
    find_minmax(numbers, min, max);

    vector <size_t> bins(bin_count);
    double bin_size = (max - min) / bin_count;
    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}
void show_histogram_text(const vector <size_t>& bins,size_t bin_count){
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 6 - 1;

    bool scaling = false;

    size_t max_count = bins[0];
    for (double x : bins){
        if (x > max_count) {
            max_count = x;
        }
    }

    if (max_count > MAX_ASTERISK){
        scaling = true;
    }

    for (size_t i = 0; i < bin_count; i++){
        cout << "   ";
        if (bins[i] < 100){
            cout << ' ';
        }
        if (bins[i] < 10){
            cout << ' ';
        }
        cout << bins[i] << '|';

        size_t number_of_stars = bins[i];

        if (scaling){
            if (bins[i] == max_count){
                number_of_stars = MAX_ASTERISK * 1.0;
            }
            else {
                number_of_stars = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
            }
        }

        for (size_t j = 0; j < number_of_stars; j++){
            cout << '*';
        }
        cout << endl;
    }
}
int main()
{
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);

    return 0;
}
